unit ConfTools;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrConfTools = class(TForm)
    edNMake: TEdit;
    lbNMake: TLabel;
    edMake: TEdit;
    lbMake: TLabel;
    bNMakeDefault: TButton;
    bMakeDefault: TButton;
    bOK: TButton;
    bCancel: TButton;
    odOpen: TOpenDialog;
    bNMakeBrowse: TButton;
    bMakeBrowse: TButton;
    edO2MPath: TEdit;
    edLink2MPath: TEdit;
    lbO2MPath: TLabel;
    lbLink2MPath: TLabel;
    edMake2MPath: TEdit;
    lbMake2MPath: TLabel;
    bO2MPathBrowse: TButton;
    bLink2MPathBrowse: TButton;
    bMake2MPathBrowse: TButton;
    bO2MPathDefault: TButton;
    bLink2MPathDefault: TButton;
    bMake2MPathDefault: TButton;
    edMakefile: TEdit;
    lbMakefile: TLabel;
    edTabSize: TEdit;
    lbTabSize: TLabel;
    bMakefileDefault: TButton;
    cbWinToOEM: TCheckBox;
    edCppPath: TEdit;
    bCppPathDefault: TButton;
    lbCppPath: TLabel;
    bCppPathBrowse: TButton;
    procedure FormShow(Sender: TObject);
    procedure bNMakeDefaultClick(Sender: TObject);
    procedure bMakeDefaultClick(Sender: TObject);
    procedure bOKClick(Sender: TObject);
    procedure bNMakeBrowseClick(Sender: TObject);
    procedure bO2MPathBrowseClick(Sender: TObject);
    procedure bLink2MPathBrowseClick(Sender: TObject);
    procedure bMake2MPathBrowseClick(Sender: TObject);
    procedure bO2MPathDefaultClick(Sender: TObject);
    procedure bLink2MPathDefaultClick(Sender: TObject);
    procedure bMake2MPathDefaultClick(Sender: TObject);
    procedure bMakeBrowseClick(Sender: TObject);
    procedure bMakefileDefaultClick(Sender: TObject);
    procedure bCppPathDefaultClick(Sender: TObject);
    procedure bCppPathBrowseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frConfTools: TfrConfTools;

const
  // O2M  
  DefaultO2MPath = 'O2M';
  //   
  DefaultTabSize = '1';
  // Link2M  
  DefaultLink2MPath = 'Link2M';
  // Make2M  
  DefaultMake2MPath = 'Make2M';
  //    C++  
  DefaultMakefile = 'Makefile.mak';
  //  NMake  
  DefaultNMakeCmdLine = 'nmake -NOLOGO -f Makefile.mak';
  //   c++  
  DefaultCppPath = 'c++';
  //  Make  
  DefaultMakeCmdLine = 'mingw32-make -f Makefile.mak';

implementation

uses Main;

{$R *.DFM}


//------------------------------------------------------------------------------
// -    
procedure TfrConfTools.FormShow(Sender: TObject);
begin
  edO2MPath.Text := frPro2M.O2MPath;
  edTabSize.Text := frPro2M.TabSize;
  edLink2MPath.Text := frPro2M.Link2MPath;
  edMake2MPath.Text := frPro2M.Make2MPath;
  edMakefile.Text := frPro2M.Makefile;
  edNMake.Text := frPro2M.NMakeCmdLine;
  edCppPath.Text := frPro2M.CppPath;
  edMake.Text := frPro2M.MakeCmdLine;
  cbWinToOEM.Checked := frPro2M.WinToOEM;
  //   OK   
  bOK.SetFocus;
end;


//------------------------------------------------------------------------------
//   NMake  
procedure TfrConfTools.bNMakeDefaultClick(Sender: TObject);
begin
  edNMake.Text := DefaultNMakeCmdLine;
end;


//------------------------------------------------------------------------------
//   Make  
procedure TfrConfTools.bMakeDefaultClick(Sender: TObject);
begin
  edMake.Text := DefaultMakeCmdLine;
end;


//------------------------------------------------------------------------------
//    
procedure TfrConfTools.bOKClick(Sender: TObject);
var ts : integer;
begin
  //    
  if '' = edO2MPath.Text then begin
    MessageDlg('   O2M', mtWarning, [mbOK], 0);
    edO2MPath.SetFocus;
    exit;
    end;
  if '' = edLink2MPath.Text then begin
    MessageDlg('   Link2M', mtWarning, [mbOK], 0);
    edLink2MPath.SetFocus;
    exit;
    end;
  if '' = edMake2MPath.Text then begin
    MessageDlg('   Make2M', mtWarning, [mbOK], 0);
    edMake2MPath.SetFocus;
    exit;
    end;
  if '' = edCppPath.Text then begin
    MessageDlg('   c++', mtWarning, [mbOK], 0);
    edCppPath.SetFocus;
    exit;
    end;
  if '' = edMakefile.Text then begin
    MessageDlg('       C++', mtWarning, [mbOK], 0);
    edMakefile.SetFocus;
    exit;
    end;
  //    TabSize
  if '' = edTabSize.Text then begin
    MessageDlg('      ', mtWarning, [mbOK], 0);
    edTabSize.SetFocus;
    exit;
    end
  else begin
    ts := -1;
    try ts := StrToInt(edTabSize.Text) except end;
    if 0 > ts then begin
      MessageDlg('      ,     ', mtWarning, [mbOK], 0);
      edTabSize.SetFocus;
      exit;
      end;
    end;
  //     NMake
  if '' = edNMake.Text then begin
    MessageDlg('     NMake', mtWarning, [mbOK], 0);
    edNMake.SetFocus;
    exit;
    end;
  //     Make
  if '' = edMake.Text then begin
    MessageDlg('     Make', mtWarning, [mbOK], 0);
    edMake.SetFocus;
    exit;
    end;

  // 
  frPro2M.O2MPath := edO2MPath.Text;
  frPro2M.TabSize := edTabSize.Text;
  frPro2M.Link2MPath := edLink2MPath.Text;
  frPro2M.Make2MPath := edMake2MPath.Text;
  frPro2M.Makefile := edMakefile.Text;
  frPro2M.NMakeCmdLine := edNMake.Text;
  frPro2M.CppPath := edCppPath.Text;
  frPro2M.MakeCmdLine := edMake.Text;
  frPro2M.WinToOEM := cbWinToOEM.Checked;

  // 
  ModalResult := mrOK;
end;


//------------------------------------------------------------------------------
//   NMake
procedure TfrConfTools.bNMakeBrowseClick(Sender: TObject);
begin
  if not odOpen.Execute then exit;
  edNMake.Text := odOpen.FileName;
end;


//------------------------------------------------------------------------------
//   O2M
procedure TfrConfTools.bO2MPathBrowseClick(Sender: TObject);
begin
  if not odOpen.Execute then exit;
  edO2MPath.Text := odOpen.FileName;
end;


//------------------------------------------------------------------------------
//   Link2M
procedure TfrConfTools.bLink2MPathBrowseClick(Sender: TObject);
begin
  if not odOpen.Execute then exit;
  edLink2MPath.Text := odOpen.FileName;
end;


//------------------------------------------------------------------------------
//   Make2M
procedure TfrConfTools.bMake2MPathBrowseClick(Sender: TObject);
begin
  if not odOpen.Execute then exit;
  edMake2MPath.Text := odOpen.FileName;
end;


//------------------------------------------------------------------------------
//  
procedure TfrConfTools.bO2MPathDefaultClick(Sender: TObject);
begin
  edO2MPath.Text := DefaultO2MPath;
end;


//------------------------------------------------------------------------------
//  
procedure TfrConfTools.bLink2MPathDefaultClick(Sender: TObject);
begin
  edLink2MPath.Text := DefaultLink2MPath;
end;


//------------------------------------------------------------------------------
//  
procedure TfrConfTools.bMake2MPathDefaultClick(Sender: TObject);
begin
  edMake2MPath.Text := DefaultMake2MPath;
end;


//------------------------------------------------------------------------------
//   Make
procedure TfrConfTools.bMakeBrowseClick(Sender: TObject);
begin
  if not odOpen.Execute then exit;
  edMake.Text := odOpen.FileName;
end;


//------------------------------------------------------------------------------
//  
procedure TfrConfTools.bMakefileDefaultClick(Sender: TObject);
begin
  edMakefile.Text := DefaultMakefile;
  edTabSize.Text := DefaultTabSize;
end;


//------------------------------------------------------------------------------
//    c++  
procedure TfrConfTools.bCppPathDefaultClick(Sender: TObject);
begin
  edCppPath.Text := DefaultCppPath;
end;


//------------------------------------------------------------------------------
//    c++
procedure TfrConfTools.bCppPathBrowseClick(Sender: TObject);
begin
  if not odOpen.Execute then exit;
  edCppPath.Text := odOpen.FileName;
end;


end.
