unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ToolWin, Menus, ExtCtrls, ImgList;

type
  TfrPro2M = class(TForm)
    sdPro: TSaveDialog;
    odFile: TOpenDialog;
    odPro: TOpenDialog;
    odPath: TOpenDialog;
    tbToolBar: TToolBar;
    tbCreatePro: TToolButton;
    ilToolBar: TImageList;
    mmMenu: TMainMenu;
    miFile: TMenuItem;
    miCreatePro: TMenuItem;
    miOpenPro: TMenuItem;
    miSavePro: TMenuItem;
    miSaveProAs: TMenuItem;
    miReopen: TMenuItem;
    miProject: TMenuItem;
    miAddFile: TMenuItem;
    miRemoveFile: TMenuItem;
    tbOpenPro: TToolButton;
    N12: TMenuItem;
    miExit: TMenuItem;
    tbSavePro: TToolButton;
    miSetMain: TMenuItem;
    tbAddFile: TToolButton;
    tbRemoveFile: TToolButton;
    tbSetMain: TToolButton;
    ToolButton7: TToolButton;
    tbCompileAll: TToolButton;
    tbMake: TToolButton;
    miRun: TMenuItem;
    miCompileAll: TMenuItem;
    miMake: TMenuItem;
    miInfo: TMenuItem;
    miAbout: TMenuItem;
    tbRunExec: TToolButton;
    miRunExec: TMenuItem;
    ToolButton2: TToolButton;
    miSettings: TMenuItem;
    miAddPath: TMenuItem;
    miRemovePath: TMenuItem;
    miPathUp: TMenuItem;
    miReopenSub1: TMenuItem;
    miReopenSub2: TMenuItem;
    miReopenSub3: TMenuItem;
    miReopenSub4: TMenuItem;
    N3: TMenuItem;
    miClear: TMenuItem;
    N4: TMenuItem;
    tbCompile: TToolButton;
    tbFileUp: TToolButton;
    miFileUp: TMenuItem;
    miClosePro: TMenuItem;
    miCompile: TMenuItem;
    ToolButton1: TToolButton;
    tbExit: TToolButton;
    pnAll: TPanel;
    splBottom: TSplitter;
    pnLog: TPanel;
    lbxLog: TListBox;
    tmLogger: TTimer;
    tmSheduller: TTimer;
    ToolButton4: TToolButton;
    tbClear: TToolButton;
    ilMainFile: TImageList;
    miConfTools: TMenuItem;
    miSettingsSplitter: TMenuItem;
    tbFileDown: TToolButton;
    miFileDown: TMenuItem;
    miPathDown: TMenuItem;
    miVersionInfo: TMenuItem;
    miInfoSplitter: TMenuItem;
    pnFilesSettings: TPanel;
    pnFiles: TPanel;
    pnClientTop: TPanel;
    lbFiles: TLabel;
    lbxFiles: TListBox;
    pgcSettings: TPageControl;
    tshSettings: TTabSheet;
    lbExecFile: TLabel;
    lbTarget: TLabel;
    edExecFile: TEdit;
    cbxTarget: TComboBox;
    cbConfirmClear: TCheckBox;
    cbUsePause: TCheckBox;
    tshDfn: TTabSheet;
    pnDfn: TPanel;
    lbxPaths: TListBox;
    tbImport: TToolBar;
    tbAddPath: TToolButton;
    tbRemovePath: TToolButton;
    tbPathUp: TToolButton;
    tbPathDown: TToolButton;
    splRight: TSplitter;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bbCompileAllClick(Sender: TObject);
    procedure bbBuildClick(Sender: TObject);
    procedure bbCreateProClick(Sender: TObject);
    procedure bbOpenProClick(Sender: TObject);
    procedure miExitClick(Sender: TObject);
    procedure bbSaveProClick(Sender: TObject);
    procedure bbSaveProAsClick(Sender: TObject);
    procedure bbSetMainClick(Sender: TObject);
    procedure bbAddFileClick(Sender: TObject);
    procedure bbRemoveFileClick(Sender: TObject);
    procedure miAboutClick(Sender: TObject);
    procedure bbRunExecClick(Sender: TObject);
    procedure bbAddPathClick(Sender: TObject);
    procedure bbRemovePathClick(Sender: TObject);
    procedure bbPathUpClick(Sender: TObject);
    procedure lbxPathsClick(Sender: TObject);
    procedure miReopenSubClick(Sender: TObject);
    procedure bbClearClick(Sender: TObject);
    procedure bbCompileClick(Sender: TObject);
    procedure bbFileUpClick(Sender: TObject);
    procedure bbCloseProClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbxLogClick(Sender: TObject);
    procedure edExecFileChange(Sender: TObject);
    procedure tmLoggerTimer(Sender: TObject);
    procedure tmShedullerTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbxTargetChange(Sender: TObject);
    procedure lbxFilesDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure miConfToolsClick(Sender: TObject);
    procedure tbFileDownClick(Sender: TObject);
    procedure tbPathDownClick(Sender: TObject);
    procedure miVersionInfoClick(Sender: TObject);
  private
    //     
    bmMainFile : TBitmap;
    //   
    MainFile : string;
    //      
    wm_need_restore : UINT;
    //  ,      
    hTmpFile : THandle;
    //    
    PInfo : TProcessInformation;
    //    
    ProErrCount : integer;
    //    (   )
    CurrFileIndex : integer;
    //    (   )
    CurrPhase : (phProCompiling,        //  ( CurrFileIndex)
                 phLink2M,              //  ( Link2M)
                 phMake2M,              // Make2M
                 phProComplete,         //  
                 phFileCompiling,       //  
                 phBuild,               //  ( Nmake, GCC, ...)
                 phVInfoO2M,            //    O2M
                 phVInfoLink2M,         //    Link2M
                 phVInfoMake2M          //    Make2M
                 );
    //   
    CompFiles : TStringList;
    //     
    procedure WriteLog(st : string);
    //     Windows
    procedure Pro2MWindowProc(var Message: TMessage);
  public
    //   O2M
    O2MPath : string;
    // 
    TabSize : string;
    //   Link2M
    Link2MPath : string;
    //   Make2M
    Make2MPath : string;
    // makefile
    Makefile : string;
    //    NMake
    NMakeCmdLine : string;
    //   c++ (MinGW)
    CppPath : string;
    //    MinGW32-Make
    MakeCmdLine : string;
    //      Win1251  OEM
    WinToOEM : boolean;
    //   ,  -   
    function load_ini(fName : string) : boolean;
    //   ,  -   
    function save_ini(fName : string) : boolean;
    //        -
    procedure CreateDefaultPro(FullFileName : string);
    //      
    procedure SetProcessRunningMode;
    //      
    procedure ClearProcessRunningMode;
  end;

var
  frPro2M: TfrPro2M;

const
  //     Windows
  wm_need_restore_string = 'Pro2MNeedRestoreMessage';

implementation

{$R *.DFM}

uses shellapi, About, miReopen, ConfTools;

var
  //  
  ProFileName : string;
  //  
  ProFilePath : string;
  //  
  chng : boolean;
const
  //    (   )   
  tmp_pro_name = 'pro2mpro.tmp';
  //      (stderr, stdout)  
  tmp_log_name = 'pro2mlog.tmp';
  //  .2mk,   O2M
  O2M_makefile = '_O2M_make.2mk';
  //    
  int_err = ' :  '; 
  //     
  v_err = '     ';
  v_done = '   ';


//------------------------------------------------------------------------------
//     Windows
procedure TfrPro2M.Pro2MWindowProc(var Message: TMessage);
begin
  //          
  if Message.Msg = wm_need_restore then Application.Restore
                                   else WndProc(Message);
end;


//------------------------------------------------------------------------------
//    ( ,     )
function GetExecFileName : string;
begin
with frPro2M do begin
  if edExecFile.Text <> '' then
    result := edExecFile.Text
  else begin
    result := MainFile;
    // 
    while (length(result) > 0) and (result[length(result)] <> '.') do
      delete(result, length(result), 1);
    //  
    if length(result) = 0 then result := MainFile + '.';
    result := result + 'exe';
    end;//else
  end;//with
end;//GetExecFileName


//------------------------------------------------------------------------------
//      
procedure set_chng;
begin
  chng := true;
  frPro2M.Caption := '[' + ProFileName + ' *] - Pro2M';
  Application.Title := frPro2M.Caption;
  frPro2M.miSavePro.Enabled := true;
  frPro2M.tbSavePro.Enabled := true;
end;


//------------------------------------------------------------------------------
//      
procedure clear_chng;
begin
  chng := false;
  if ProFileName = '' then frPro2M.Caption := 'Pro2M'
                      else frPro2M.Caption := '[' + ProFileName + '] - Pro2M';
  Application.Title := frPro2M.Caption;
  frPro2M.miSavePro.Enabled := false;
  frPro2M.tbSavePro.Enabled := false;
end;


//------------------------------------------------------------------------------
//   
procedure clear_pro;
begin
  with frPro2M do begin
    lbxLog.Clear;
    lbxFiles.Clear;
    MainFile := '';
    edExecFile.Text := '';
    cbxTarget.ItemIndex := 0;
    cbxTarget.Hint := cbxTarget.Text;
    end;//with
  ProFileName := '';
  ProFilePath := '';
  clear_chng;
end;//clear_pro


//------------------------------------------------------------------------------
//   ,  -   
function TfrPro2M.load_ini(fName : string) : boolean;
var f : TextFile;
    st, sst : string;
    i : integer;
    ts : integer;
begin
  result := true;
try
  lbxPaths.Clear;
  AssignFile(f, fName);
  Reset(f);
  // 
  miReopen_Clear(miReopen);
  //  
  repeat
    // ,    
    readln(f, st);
    st := Trim(st);
    if st = '' then continue else if (st[1] = ';') or (st[1] = '#') then continue;
    //     '=' ( )
    i := 1;
    while (i < length(st)) and (st[i]<>'=') do inc(i);
    if st[i] <> '=' then continue;
    sst := TrimRight(copy(st, 1, i-1));
    st := TrimLeft(copy(st, i+1, length(st)));
    //         ( )
    i := length(st);
    if i > 1 then
      if (('''' = st[1]) and ('''' = st[i])) or (('"' = st[1]) and ('"' = st[i])) then
        st := copy(st, 2, i - 2);

    //    sst = st

    //IMPORT 
    if 'IMPORT' = sst then lbxPaths.Items.Append(st);
    //  
    if 'REOPEN' = sst then miReopen_Add(miReopen, st);
    //  (     )
    if 'TABSIZE' = sst then
      try
        ts := StrToInt(st);
        if ts < 0 then ts := 1;
        TabSize := IntToStr(ts);
      except
        TabSize := '1';
        end;
    //  
    if 'O2M' = sst then O2MPath := st;
    //  
    if 'LINK2M' = sst then Link2MPath := st;
    //  make'
    if 'MAKE2M' = sst then Make2MPath := st;
    // makefile
    if 'MAKEFILE' = sst then Makefile := st;
    //   NMake
    if 'NMAKE' = sst then NMakeCmdLine := st;
    //   c++
    if 'CPP' = sst then CppPath := st;
    //   Make
    if 'MAKE' = sst then MakeCmdLine := st;
    //  
    if 'WINTOOEM' = sst then WinToOEM := '1' = st;
    //      
    if 'CONFIRMCLEAR' = sst then cbConfirmClear.Checked := '1' = st;
    //     
    if 'USEPAUSE' = sst then cbUsePause.Checked := '1' = st;

  until Eof(f);
  CloseFile(f);
except
  result := false;
  end;//try
end;//load_ini


//------------------------------------------------------------------------------
//   ,  -   
function TfrPro2M.save_ini(fName : string) : boolean;
var f : TextFile;
    i : integer;
begin
  result := true;
try
  AssignFile(f, fName);
  Rewrite(f);
  // 
  writeln(f, '[Pro2M]');
  //  
  for i := 0 to lbxPaths.Items.Count-1 do
    writeln(f, 'IMPORT=' + lbxPaths.Items[i]);
  //   
  for i := (miReopen.Count - 1) downto 0 do
    if miReopen.Items[i].Visible and miReopen.Items[i].Enabled then
      writeln(f, 'REOPEN=' + miReopen.Items[i].Caption);
  //   
  writeln(f, 'O2M=' + O2MPath);
  //   
  writeln(f, 'LINK2M=' + Link2MPath);
  //   make'
  writeln(f, 'MAKE2M=' + Make2MPath);
  //  makefile
  writeln(f, 'MAKEFILE=' + Makefile);
  //  
  writeln(f, 'TABSIZE=' + TabSize);
  //   NMake
  writeln(f, 'NMAKE=' + NMakeCmdLine);
  //    c++
  writeln(f, 'CPP=' + CppPath);
  //   Make
  writeln(f, 'MAKE=' + MakeCmdLine);
  //   
  write(f, 'WINTOOEM=');
  if WinToOEM then writeln(f, '1') else writeln(f, '0');
  //       
  write(f, 'CONFIRMCLEAR=');
  if cbConfirmClear.Checked then writeln(f, '1') else writeln(f, '0');
  //      
  write(f, 'USEPAUSE=');
  if cbUsePause.Checked then writeln(f, '1') else writeln(f, '0');
  // 
  CloseFile(f);
except
  result := false;
  end;//try
end;//save_ini


//------------------------------------------------------------------------------
//   ,    
// -   
function SaveTmpProject : boolean;
var hTmpPro : THandle;                  //    
    buf : array [0..267] of char;       //    (256 - .   + . )
    i : integer;
    len : Cardinal;
label
    FaultExit;                          //    
begin
with frPro2M do begin
  result := false;

  //     
  hTmpPro := CreateFile(tmp_pro_name, GENERIC_WRITE, 0, nil, CREATE_ALWAYS, FILE_ATTRIBUTE_HIDDEN + FILE_ATTRIBUTE_TEMPORARY, 0);
  if hTmpPro = INVALID_HANDLE_VALUE then exit;

  //  
  for i := 0 to lbxPaths.Items.Count - 1 do begin
    //   (      )
    len := Length(lbxPaths.Items[i]);
    if len > 256 then goto FaultExit;
    StrPCopy(buf, 'IMPORT=' + lbxPaths.Items[i] + #13#10);
    inc(len, 9);
    //   (   )
    if not WriteFile(hTmpPro, buf, len, len, nil) then goto FaultExit;
    end;

  //    
  if MainFile <> '' then begin
    //   (      )
    len := Length(MainFile);
    if len > 256 then goto FaultExit;
    StrPCopy(buf, 'MAIN=' + MainFile + #13#10);
    inc(len, 7);
    //  (   )
    if not WriteFile(hTmpPro, buf, len, len, nil) then goto FaultExit;
    end;
    
  //   
  if edExecFile.Text <> '' then begin
    //   (      )
    len := Length(edExecFile.Text);
    if len > 256 then goto FaultExit;
    StrPCopy(buf, 'EXEC=' + edExecFile.Text + #13#10);
    inc(len, 7);
    //  (   )
    if not WriteFile(hTmpPro, buf, len, len, nil) then goto FaultExit;
    end;

  //  
  len := Length(TabSize);
  if len > 256 then goto FaultExit;
  StrPCopy(buf, 'TABSIZE=' + TabSize + #13#10);
  inc(len, 10);
  if not WriteFile(hTmpPro, buf, len, len, nil) then goto FaultExit;

  //   
  result := true;

FaultExit:

  //  
  if not CloseHandle(hTmpPro) then result := false;
  end;//with
end;


//------------------------------------------------------------------------------
//    
function load_pro(fName : string) : boolean;
var f : TextFile;
    st, sst : string;
    i : integer;
begin
with frPro2M do
try
  AssignFile(f, fName);
  Reset(f);

  clear_pro;
  ProFileName := fName;
  ProFilePath := ExtractFilePath(fName);
  SetCurrentDir(ProFilePath);
  //   \CPP, \DFN
  try MkDir('CPP') except end;
  try MkDir('DFN') except end;
  try MkDir('Make') except end;

  //  
  repeat
    // ,    
    readln(f, st);
    st := Trim(st);
    if st = '' then continue else if (st[1] = ';') or (st[1] = '#') then continue;
    //     '=' ( )
    i := 1;
    while (i < length(st)) and (st[i]<>'=') do inc(i);
    if st[i] <> '=' then continue;
    sst := TrimRight(copy(st, 1, i-1));
    st := TrimLeft(copy(st, i+1, length(st)));
    //         ( )
    i := length(st);
    if i > 1 then
      if (('''' = st[1]) and ('''' = st[i])) or (('"' = st[1]) and ('"' = st[i])) then
        st := copy(st, 2, i - 2);

    //    sst = st

    // 
    if 'FILE' = sst then lbxFiles.Items.Append(st);
    //  
    if 'MAIN' = sst then MainFile := st;
    //  
    if 'EXEC' = sst then edExecFile.Text := st;
    // 
    if 'TARGET' = sst then
      try
        cbxTarget.ItemIndex := StrToInt(st);
        cbxTarget.Hint := cbxTarget.Text;
      except
        on EConvertError do MessageDlg('   TARGET   ', mtError, [mbOK], 0);
        end;//try

  until Eof(f);

  CloseFile(f);
  clear_chng;
  result := true;
except
  clear_pro;
  messagedlg('   "' + fName + '"', mtError, [mbOK], 0);
  result := false;
  end;//try
end;//load_pro


//------------------------------------------------------------------------------
//    
procedure SaveProject(fName : string);
var f : TextFile;
    i : integer;
begin
with frPro2M do
try
  AssignFile(f, fName);
  Rewrite(f);
  //  
  for i := 0 to lbxPaths.Items.Count-1 do
    writeln(f, 'IMPORT=' + lbxPaths.Items[i]);
  //    
  if MainFile <> '' then writeln(f, 'MAIN=' + MainFile);
  //    
  if edExecFile.Text <> '' then writeln(f, 'EXEC=' + edExecFile.Text);
  //  
  writeln(f, 'TARGET=' + IntToStr(cbxTarget.ItemIndex));
  //  
  for i := 0 to lbxFiles.Items.Count-1 do
    writeln(f, 'FILE=' + lbxFiles.Items[i]);
  //   
  CloseFile(f);
  ProFileName := fName;
  ProFilePath := ExtractFilePath(fName);
  SetCurrentDir(ProFilePath);
  clear_chng;
except
  messagedlg('    "' + fName + '"', mtError, [mbOK], 0);
  end;//try
end;//SaveProject


//------------------------------------------------------------------------------
//        -
procedure TfrPro2M.CreateDefaultPro(FullFileName : string);
var FileName : string;  //    
    inum : integer;
    path : string;      //      
begin
  //   
  if UpperCase(ExtractFileExt(FullFileName)) = '.PRO' then begin
    if load_pro(FullFileName) then miReopen_Add(miReopen, FullFileName);
    end
  else //    
    if MessageDlg('     "' + FullFileName + '" ?', mtConfirmation, [mbYes, mbCancel], 0) = mrYes then begin
      //  
      FileName := ExtractFileName(FullFileName);
      sdPro.InitialDir := ExtractFilePath(FullFileName);
      sdPro.FileName := ChangeFileExt(FileName, '.pro');
      if sdPro.Execute then begin

        //   
        //       (..     )
        path := ExtractFilePath(sdPro.FileName);
        //    8.3 (..       -)
        path := ExtractShortPathName(path);
        //     
        path := ExtractRelativePath(path, FullFileName);
        //    
        inum := lbxFiles.Items.Add(path);

        //     (   )
        SetForegroundWindow(Application.Handle);
        //   
        if MessageDlg('  "' + FullFileName + '"    ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
          MainFile := lbxFiles.Items[inum];
        //     
        edExecFile.Text := ChangeFileExt(FileName, '.exe');
        //    
        cbxTarget.ItemIndex := 0;
        cbxTarget.Hint := cbxTarget.Text;
        //  
        SetCurrentDir(sdPro.FileName);
        SaveProject(sdPro.FileName);
        miReopen_Add(miReopen, sdPro.FileName);
        try MkDir('CPP') except MessageDlg('      (\CPP, \DFN),        ?', mtWarning, [mbOK], 0) end;
        try MkDir('DFN') except end;
        try MkDir('Make') except end;
        end;//if
      sdPro.InitialDir := '';
      end;//if
end;//CreateDefaultPro


//------------------------------------------------------------------------------
//
procedure TfrPro2M.FormCreate(Sender: TObject);
begin
  //  Windows         WindowProc   
  wm_need_restore := RegisterWindowMessage(wm_need_restore_string);
  if wm_need_restore <> 0 then frPro2M.WindowProc := Pro2MWindowProc;
  //      
  bmMainFile := TBitmap.Create;
  ilMainFile.GetBitmap(0, bmMainFile);
  //    
  CompFiles := TStringList.Create;
  CompFiles.Sorted := false;
  //   lbxFiles    
  lbxFiles.ItemHeight := Canvas.TextHeight('Ipyfgjl') + 3;
  if lbxFiles.ItemHeight < bmMainFile.Height then lbxFiles.ItemHeight := bmMainFile.Height;
  //   
  Application.HintHidePause := 10000;
  ProFileName := '';
  ProFilePath := '';
  TabSize := DefaultTabSize;
  O2MPath := DefaultO2MPath;
  Link2MPath := DefaultLink2MPath;
  Make2MPath := DefaultMake2MPath;
  Makefile := DefaultMakefile;
  NMakeCmdLine := DefaultNMakeCmdLine;
  CppPath := DefaultCppPath;
  MakeCmdLine := DefaultMakeCmdLine;
  chng := false;
end;


//------------------------------------------------------------------------------
//
procedure TfrPro2M.FormClose(Sender: TObject; var Action: TCloseAction);
var mres : TModalResult;
begin
  //    
  if chng then begin
    mres := MessageDlg('   ?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    if mres = mrCancel then begin
      Action := caNone;
      exit;
      end;
    if mres = mrYes then bbSaveProClick(nil);
    end;//if

  //   
  if tmLogger.Enabled then begin
    tmSheduller.Enabled := false;
    tmLogger.Enabled := false;
    // 
    CloseHandle(frPro2M.hTmpFile);
    end;

  //  
  save_ini( ExtractFilePath(ParamStr(0)) + 'Pro2M.ini' );
end;


//------------------------------------------------------------------------------
//     
procedure TfrPro2M.WriteLog(st : string);
const max_count = 1000;  //    
begin
with lbxLog do begin
  Items.Append(st);
  if Items.Count > max_count then Items.Delete(0);
  TopIndex := Items.Count - 1;
  end;//with
end;


//------------------------------------------------------------------------------
//   
procedure ClearLog;
begin
  frPro2M.lbxLog.Clear;
  frPro2M.lbxLog.Hint := '';
end;//ClearLog


//------------------------------------------------------------------------------
//      (   )
procedure EraseFiles(fPath, fMask : string);
var SearchRec : TSearchRec;
    Found : integer;
begin
  Found := FindFirst(fPath + fMask, faAnyFile, SearchRec);
  while Found = 0 do begin
    if not DeleteFile(fPath + SearchRec.Name) then
      frPro2M.WriteLog('   "' + fPath + SearchRec.Name + '"');
    Found := FindNext(SearchRec);
    end;//while
  FindClose(SearchRec);
end;


//------------------------------------------------------------------------------
//      
procedure TfrPro2M.SetProcessRunningMode;
begin
  //    
  tbClear.Enabled := false;
  tbCompile.Enabled := false;
  tbCompileAll.Enabled := false;
  tbMake.Enabled := false;
  //  
  miClear.Enabled := false;
  miCompile.Enabled := false;
  miCompileAll.Enabled := false;
  miMake.Enabled := false;
end;


//------------------------------------------------------------------------------
//      
procedure TfrPro2M.ClearProcessRunningMode;
begin
  //    
  tbClear.Enabled := true;
  tbCompile.Enabled := true;
  tbCompileAll.Enabled := true;
  tbMake.Enabled := true;
  //  
  miClear.Enabled := true;
  miCompile.Enabled := true;
  miCompileAll.Enabled := true;
  miMake.Enabled := true;
end;


//------------------------------------------------------------------------------
//     
function RunCreateProcess (CmdLine : string; show_window : boolean) : boolean;
var
  SInfo : TStartupInfo;
  SecAttr : TSecurityAttributes;
  CPResult : bool;
  hTmpFile : THandle;
  pCmdLine : pchar;       //   
begin
  result := false;        //    

  //,    (   ,     )
  if frPro2M.tmLogger.Enabled then begin
    //    , ..    ,    (,    )
    //    - ,    
    MessageDlg(' :    ', mtError, [mbOk], 0);
    exit;
    end;

  //   (  Windows NT/2000/XP)
  SecAttr.nLength := SizeOf(TSecurityAttributes);
  SecAttr.lpSecurityDescriptor := nil;
  SecAttr.bInheritHandle := true;       //    

  //    
  hTmpFile := CreateFile(tmp_log_name, GENERIC_WRITE, FILE_SHARE_READ + FILE_SHARE_WRITE, @SecAttr, CREATE_ALWAYS, FILE_ATTRIBUTE_HIDDEN + FILE_ATTRIBUTE_TEMPORARY, 0);
  if hTmpFile = INVALID_HANDLE_VALUE then begin
    frPro2M.WriteLog(' :   -');
    exit;
    end;//if

  //  
  getmem(pCmdLine, length(cmdLine) + 1);
  StrPCopy(pCmdLine, cmdLine);

  //    CreateProcess
  with SInfo do begin
    cb := SizeOf(TStartupInfo);
    lpReserved := nil;
    lpDesktop := nil;
    lpTitle := nil;
    dwFlags := STARTF_USESHOWWINDOW + STARTF_FORCEONFEEDBACK + STARTF_USESTDHANDLES;
    if show_window then wShowWindow := SW_SHOWNORMAL
                   else wShowWindow := SW_HIDE;
    cbReserved2 := 0;
    lpReserved2 := nil;
    hStdInput := hTmpFile;
    hStdOutput := hTmpFile;
    hStdError := hTmpFile;
    end;//with

  try
    CPResult := CreateProcess(
      nil,                      //lpApplicationName
      pCmdLine,                 //lpCommandLine
      nil,                      //lpProcessAttributes
      nil,                      //lpThreadAttributes
      true,                     //bInheritHandles
      CREATE_NEW_CONSOLE,       //dwCreationFlags
      nil,                      //lpEnvironment
      nil,                      //lpCurrentDirectory
      SInfo,                    //lpStartupInfo
      frPro2M.PInfo             //lpProcessInformation
      );
  finally
    //  
    freemem(pCmdLine, length(cmdLine) + 1);
    end;//try

  // 
  if not CloseHandle(hTmpFile) then begin
    frPro2M.WriteLog(' :   -');
    exit;
    end;

  //,    
  if not CPResult then begin
    //  
    DeleteFile(tmp_log_name);
    exit;
    end;

  //        ,     
  frPro2M.hTmpFile := CreateFile(tmp_log_name, GENERIC_READ, FILE_SHARE_READ + FILE_SHARE_WRITE, nil, OPEN_EXISTING, FILE_ATTRIBUTE_HIDDEN + FILE_ATTRIBUTE_TEMPORARY, 0);
  if frPro2M.hTmpFile = INVALID_HANDLE_VALUE then begin
    frPro2M.WriteLog(' :       -');
    exit;
    end;//if

  //       
  frPro2M.SetProcessRunningMode;

  //     -
  frPro2M.tmLogger.Enabled := true;
  result := true;
end;//RunCreateProcess


//------------------------------------------------------------------------------
//  
procedure TfrPro2M.bbCompileAllClick(Sender: TObject);
var SaveCursor : TCursor;
    i : integer;
begin
  SaveCursor := Screen.Cursor;
  Screen.Cursor := crHourglass;
  try
    //      
    if ProFileName = '' then begin
      MessageDlg('     ', mtWarning, [mbOK], 0);
      exit;
      end;
    if lbxFiles.Items.Count = 0 then begin
      MessageDlg('   ', mtWarning, [mbOK], 0);
      exit;
      end;//if
    ClearLog;

    //  
    if not SetCurrentDir(ProFilePath) then begin
      MessageDlg('     (' + ProFilePath + ')', mtError, [mbOK], 0);
      WriteLog(int_err);
      exit;
      end;

    // O2M_makefile       ( )
    if FileExists('CPP\' + O2M_makefile) then
      if not DeleteFile('CPP\' + O2M_makefile) then begin
        MessageDlg('    "CPP\' + O2M_makefile + '"', mtError, [mbOK], 0);
        WriteLog(int_err);
        exit;
        end;

    //      
    if not SaveTmpProject then begin
      MessageDlg('       ', mtError, [mbOK], 0);
      WriteLog(int_err);
      exit;
      end;

    //  
    CompFiles.Clear;
    for i := 0 to lbxFiles.Items.Count - 1 do CompFiles.Append(lbxFiles.Items[i]);

    //   
    WriteLog(' ...');
    CurrFileIndex := 0;
    ProErrCount := 0;
    //   
    CurrPhase := phProCompiling;
    //  
    tmSheduller.Enabled := true;

  finally
    Screen.Cursor := SaveCursor;
    end;//finally
end;


//------------------------------------------------------------------------------
//   
procedure TfrPro2M.bbBuildClick(Sender: TObject);
var SaveCursor : TCursor;
begin
  SaveCursor := Screen.Cursor;
  Screen.Cursor := crHourglass;
  try
    //   
    if '' = ProFileName then begin
      MessageDlg('     ', mtWarning, [mbOK], 0);
      exit;
      end;

    // 
    ClearLog;

    //   
    SetCurrentDir(ProFilePath + 'CPP\');

    if not FileExists(Makefile) then begin
      MessageDlg('   ', mtWarning, [mbOK], 0);
      WriteLog(' :   ');
      SetCurrentDir(ProFilePath);
      exit;
      end;

    //    (     nmake      )
    EraseFiles(ProFilePath + 'Make\', GetExecFileName);
    if FileExists(ProFilePath + 'Make\' + GetExecFileName) then begin
      WriteLog('       ');
      SetCurrentDir(ProFilePath);
      exit;
      end;

    //   C++
    WriteLog('  ...');
    WriteLog('');
    CurrPhase := phBuild;
    ProErrCount := 0;
    //     
    if 2 <= cbxTarget.ItemIndex then begin
      if not RunCreateProcess(MakeCmdLine, false) then begin
        WriteLog('   mingw32-make');
        SetCurrentDir(ProFilePath);
        end;
      end
    else
      if not RunCreateProcess(NMakeCmdLine, false) then begin
        MessageDlg('   nmake -      VC++ ( VCVARS32.BAT    AUTOEXEC.BAT)', mtError, [mbOK], 0);
        WriteLog('   nmake');
        SetCurrentDir(ProFilePath);
        end;

  finally
    Screen.Cursor := SaveCursor;
    end;//finally
end;


//------------------------------------------------------------------------------
//  
procedure TfrPro2M.bbCreateProClick(Sender: TObject);
var mres : TModalResult;
begin
  if chng then begin
    mres := MessageDlg('   ?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    if mres = mrCancel then exit;
    if mres = mrYes then bbSaveProClick(Sender);
    end;//if
  sdPro.FileName := 'new.pro';
  if not sdPro.Execute then exit;
  //   
  clear_pro;
  SetCurrentDir(ExtractFilePath(sdPro.FileName));
  SaveProject(sdPro.FileName);
  miReopen_Add(miReopen, sdPro.FileName);
  //  
  try MkDir('CPP') except MessageDlg('     (\CPP, \DFN),        ?', mtWarning, [mbOK], 0) end;
  try MkDir('DFN') except end;
  try MkDir('Make') except end;
end;


//------------------------------------------------------------------------------
//
procedure TfrPro2M.bbOpenProClick(Sender: TObject);
var mres : TModalResult;
begin
  if not odPro.Execute then exit;
  //    
  if chng then begin
    mres := MessageDlg('   ?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    if mres = mrCancel then exit;
    if mres = mrYes then bbSaveProClick(nil);
    end;//if
  //      
  if load_pro(odPro.FileName) then miReopen_Add(miReopen, odPro.FileName);
end;


//------------------------------------------------------------------------------
//
procedure TfrPro2M.miExitClick(Sender: TObject);
begin
  frPro2M.Close;
end;


//------------------------------------------------------------------------------
//
procedure TfrPro2M.bbSaveProClick(Sender: TObject);
begin
  if ProFileName = '' then
    if not sdPro.Execute then exit else begin
      SaveProject(sdPro.FileName);
      exit;
      end;//else
  SaveProject(ProFileName);
end;


//------------------------------------------------------------------------------
//
procedure TfrPro2M.bbSaveProAsClick(Sender: TObject);
begin
  if not sdPro.Execute then exit;
  SaveProject(sdPro.FileName);
end;


//------------------------------------------------------------------------------
//   
procedure TfrPro2M.bbSetMainClick(Sender: TObject);
begin
  if lbxFiles.ItemIndex < 0 then begin
    MessageDlg('  ', mtWarning, [mbOK], 0);
    exit;
    end;//if
  if MessageDlg('      ?', mtConfirmation, [mbYes, mbCancel], 0) <> mrYes then exit;
  MainFile := lbxFiles.Items[lbxFiles.ItemIndex];
  lbxFiles.Repaint;
  set_chng;
end;


//------------------------------------------------------------------------------
//   
procedure TfrPro2M.bbAddFileClick(Sender: TObject);
var i : integer;
    fName : string;
begin
  if (not odFile.Execute) or (odFile.Files.Count = 0) then exit;
  //   
  if '' = ProFileName then begin
    //   
    CreateDefaultPro(odFile.Files[0]);
    //   ,    
    if '' <> ProFileName then
      for i := 1 to odFile.Files.Count-1 do begin
        fName := ExtractRelativePath(ProFilePath, odFile.Files[i]);
        lbxFiles.Items.Append(fName);
        end;//for
    exit;
    end;//if
  //    
  for i := 0 to odFile.Files.Count-1 do begin
    fName := ExtractRelativePath(ProFilePath, odFile.Files[i]);
    if lbxFiles.Items.IndexOf(fName) < 0 then
      lbxFiles.Items.Append(fName)
    else
      MessageDlg(' "' + fName + '"    ', mtInformation, [mbOK], 0);
    end;//for
  set_chng;
end;


//------------------------------------------------------------------------------
//
procedure TfrPro2M.bbRemoveFileClick(Sender: TObject);
begin
  if lbxFiles.ItemIndex < 0 then begin
    MessageDlg('  ', mtWarning, [mbOK], 0);
    exit;
    end;//if
  if MessageDlg('     ?', mtConfirmation, [mbYes, mbCancel], 0) <> mrYes then exit;
  if MainFile = lbxFiles.Items[lbxFiles.ItemIndex] then MainFile := '';
  lbxFiles.Items.Delete(lbxFiles.ItemIndex);
  set_chng;
end;


//------------------------------------------------------------------------------
//
procedure TfrPro2M.miAboutClick(Sender: TObject);
begin
  frAbout.ShowModal;
end;


//------------------------------------------------------------------------------
//    ( )
procedure TfrPro2M.bbRunExecClick(Sender: TObject);
var st_name : string;   //  
    bat_name : string;  //     
    res : integer;
    f : TextFile;

begin
  if ProFileName = '' then begin
    MessageDlg('     ', mtWarning, [mbOK], 0);
    exit;
    end;

  //   
  SetCurrentDir(ProFilePath + 'Make');
  
  //  exe-
  st_name := GetExecFileName;
  bat_name := st_name + '.bat';

  if not FileExists(st_name) then begin
    MessageDlg('      nmake,      ', mtWarning, [mbOK], 0);
    SetCurrentDir(ProFilePath);
    exit;
    end;

  //  
  try
    AssignFile(f, bat_name);
    Rewrite(f);
    writeln(f, '@' + st_name);
    writeln(f, '@echo.');
    if cbUsePause.Checked then writeln(f, '@PAUSE');
    CloseFile(f);
  except
    MessageDlg('    "' + bat_name + '"', mtError, [mbOk], 0);
    SetCurrentDir(ProFilePath);
    exit;
    end;

  res := ShellExecute(handle, nil, PChar(bat_name), nil, nil, SW_SHOWNORMAL);
  //  
  if res <= 32 then begin
    MessageDlg('    ', mtError, [mbOK], 0);
    end;
  SetCurrentDir(ProFilePath);
end;


//------------------------------------------------------------------------------
//
procedure TfrPro2M.bbAddPathClick(Sender: TObject);
var fName : string;
begin
  //    
  if not odPath.Execute then exit;
  //     
  pgcSettings.ActivePage := tshDfn;
  //    
  fName := ExtractFilePath(odPath.FileName);
  if lbxPaths.Items.IndexOf(fName) < 0 then lbxPaths.Items.Append(fName)
  else MessageDlg(' "' + fName + '"    ', mtInformation, [mbOK], 0);
end;


//------------------------------------------------------------------------------
//
procedure TfrPro2M.bbRemovePathClick(Sender: TObject);
var i : integer;
begin
  //   
  if (tshDfn <> pgcSettings.ActivePage) or (lbxPaths.ItemIndex < 0) then begin
    MessageDlg('  ', mtWarning, [mbOK], 0);
    exit;
    end;//if
  //  
  i := lbxPaths.ItemIndex;
  if MessageDlg('   ?', mtConfirmation, [mbYes, mbCancel], 0) <> mrYes then exit;
  lbxPaths.Items.Delete(lbxPaths.ItemIndex);
  //   
  if i >= lbxPaths.Items.Count then i := lbxPaths.Items.Count - 1;
  lbxPaths.ItemIndex := i;
end;


//------------------------------------------------------------------------------
//  
procedure TfrPro2M.bbPathUpClick(Sender: TObject);
begin
  //   
  if lbxPaths.ItemIndex < 0 then begin
    MessageDlg('  ', mtWarning, [mbOK], 0);
    exit;
    end;//if
  //     
  if lbxPaths.ItemIndex = 0 then exit;
  //   
  lbxPaths.Items.Exchange(lbxPaths.ItemIndex, lbxPaths.ItemIndex - 1);
end;


//------------------------------------------------------------------------------
//
procedure TfrPro2M.lbxPathsClick(Sender: TObject);
begin
  if lbxPaths.ItemIndex >= 0 then lbxPaths.Hint := lbxPaths.Items[lbxPaths.ItemIndex];
end;


//------------------------------------------------------------------------------
//
procedure TfrPro2M.miReopenSubClick(Sender: TObject);
var mres : TModalResult;
begin
  //    
  if chng then begin
    mres := MessageDlg('   ?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    if mres = mrCancel then exit;
    if mres = mrYes then bbSaveProClick(nil);
    end;//if
  //    miReopen
  if load_pro(TMenuItem(Sender).Caption) then miReopen_Add(miReopen, TMenuItem(Sender).Caption)
                                         else miReopen_Del(miReopen, TMenuItem(Sender).Caption);
end;


//------------------------------------------------------------------------------
//  (  )
procedure TfrPro2M.bbClearClick(Sender: TObject);
begin
  //  
  if ProFileName = '' then begin
    MessageDlg('   ', mtWarning, [mbOK], 0);
    exit;
    end;
  //     ( )
  if cbConfirmClear.Checked then
    if MessageDlg('    (\CPP, \DFN, \Make) ?', mtConfirmation, [mbYes, mbCancel], 0) <> mrYes then
      exit;
  ClearLog;

  //  \CPP
  EraseFiles(ProFilePath + 'CPP\', '*.cpp');
  EraseFiles(ProFilePath + 'CPP\', '*.h');
  EraseFiles(ProFilePath + 'CPP\', '*.2ml');
  EraseFiles(ProFilePath + 'CPP\', O2M_makefile);
  EraseFiles(ProFilePath + 'CPP\', Makefile);
  //  \DFN
  EraseFiles(ProFilePath + 'DFN\', '*.dfn');
  //  \Make
  EraseFiles(ProFilePath + 'Make\', '*.bat');
  EraseFiles(ProFilePath + 'Make\', '*.exe');
  EraseFiles(ProFilePath + 'Make\', '*.idb');
  EraseFiles(ProFilePath + 'Make\', '*.obj');
  EraseFiles(ProFilePath + 'Make\', '*.pch');
  // <tmp_log_name>, <tmp_pro_name> ( )
  EraseFiles(ProFilePath, tmp_log_name);
  EraseFiles(ProFilePath, tmp_pro_name);

  WriteLog('    ');
end;


//------------------------------------------------------------------------------
//   
procedure TfrPro2M.bbCompileClick(Sender: TObject);
var st : string;
    SaveCursor : TCursor;
begin
  SaveCursor := Screen.Cursor;
  Screen.Cursor := crHourglass;
  try
    if ProFileName = '' then begin
      MessageDlg('     ', mtWarning, [mbOK], 0);
      exit;
      end;
    if lbxFiles.ItemIndex < 0 then begin
      MessageDlg('  ', mtWarning, [mbOK], 0);
      exit;
      end;
    ClearLog;

    //  
    if not SetCurrentDir(ProFilePath) then begin
      MessageDlg('     (' + ProFilePath + ')', mtError, [mbOK], 0);
      WriteLog(int_err);
      exit;
      end;

    //      
    if not SaveTmpProject then begin
      MessageDlg('       ', mtError, [mbOK], 0);
      WriteLog(int_err);
      exit;
      end;

    //     
    st := '"' + lbxFiles.Items[ lbxFiles.ItemIndex ] + '"';
    WriteLog(' ' + st + '...');
    //    
    CurrPhase := phFileCompiling;
    //     ()
    if not RunCreateProcess('"' + O2MPath + '" ' + st + ' ' + tmp_pro_name + ' -a', false) then begin
      WriteLog('    ' + st);
      DeleteFile(tmp_pro_name);
      end;
      
  finally
    Screen.Cursor := SaveCursor;
    end;//finally
end;


//------------------------------------------------------------------------------
//  
procedure TfrPro2M.bbFileUpClick(Sender: TObject);
begin
  //   
  if lbxFiles.ItemIndex < 0 then begin
    MessageDlg('  ', mtWarning, [mbOK], 0);
    exit;
    end;//if
  //     
  if lbxFiles.ItemIndex = 0 then exit;
  //   
  lbxFiles.Items.Exchange(lbxFiles.ItemIndex, lbxFiles.ItemIndex - 1);
  set_chng;
end;


//------------------------------------------------------------------------------
//
procedure TfrPro2M.bbCloseProClick(Sender: TObject);
var mres : TModalResult;
begin
  //  
  if chng then begin
    mres := MessageDlg('   ?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    if mres = mrCancel then exit;
    if mres = mrYes then bbSaveProClick(nil);
    end;//if
  clear_pro;  //  
end;


//------------------------------------------------------------------------------
//   
procedure TfrPro2M.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //   
  case Key of
    77: if ssCtrl in Shift then //Ctrl + M
      bbSetMainClick(Sender);
    78: if ssCtrl in Shift then //Ctrl + N
      bbCreateProClick(Sender);
    79: if ssCtrl in Shift then //Ctrl + O
      bbOpenProClick(Sender);
    83: if ssCtrl in Shift then //Ctrl + S
      bbSaveProClick(Sender);
    85: if ssCtrl in Shift then //Ctrl + U
      bbFileUpClick(Sender);
    68: if ssCtrl in Shift then //Ctrl + D
      tbFileDownClick(Sender);
    88: if ssAlt in Shift then //Alt + X
      miExit.Click;
    187: if ssCtrl in Shift then //Ctrl + '='
      bbAddFileClick(Sender);
    189: if ssCtrl in Shift then //Ctrl + '-'
      bbRemoveFileClick(Sender);
    116: //F5
      bbRunExecClick(Sender);
    118: //Ctrl + F7
      if ssCtrl in Shift then begin
        if tbCompile.Enabled then bbCompileClick(Sender);
        end
      else begin //F7
        if tbCompileAll.Enabled then bbCompileAllClick(Sender);
        end;
    119: //F8
      if tbMake.Enabled then bbBuildClick(Sender);
    end;//case
end;


//------------------------------------------------------------------------------
//
procedure TfrPro2M.lbxLogClick(Sender: TObject);
begin
  // Hint   
  if lbxLog.ItemIndex >= 0 then
    lbxLog.Hint := lbxLog.Items[lbxLog.ItemIndex];
end;


//------------------------------------------------------------------------------
//   
procedure TfrPro2M.edExecFileChange(Sender: TObject);
begin
  //     
  set_chng;
end;


//------------------------------------------------------------------------------
//    
procedure TfrPro2M.tmLoggerTimer(Sender: TObject);
const
    buf_size = 10000;                       //.  ,    
var buf, s : array [0..buf_size] of char;   // 1   #0
    num : Cardinal;
    beg, i : Cardinal;
    hWr : THandle;
label
    skip_phase;                             //    
begin
  //  (    )
  tmLogger.Enabled := false;

  // ,          
  while ReadFile(hTmpFile, buf, buf_size, num, nil) and (num > 0) do begin
    //    
    i := 0;
    while i < num do begin
      beg := i;
      while (buf[i] <> #13) and (i < num) do begin
        if buf[i] = #9 then buf[i] := ' ';
        inc(i);
        end;
      move(buf[beg], s, i - beg);
      s[i - beg] := #0;
      WriteLog(s);
      if buf[i + 1] = #10 then inc(i);
      inc(i);
      end;//while
    //    (     ReadFile)
    if buf_size > num then break;
    end;

  //     (       )
  hWr := CreateFile(tmp_log_name, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, FILE_ATTRIBUTE_HIDDEN + FILE_ATTRIBUTE_TEMPORARY, 0);
  if hWr <> INVALID_HANDLE_VALUE then begin     //  =>    
    //  
    CloseHandle(hWr);
    CloseHandle(hTmpFile);
    //  
    DeleteFile(tmp_log_name);

    /////////////////////////////////////////
    //    
    skip_phase:
    case CurrPhase of

      //   ,            
      phFileCompiling: begin
        DeleteFile(tmp_pro_name);
        ClearProcessRunningMode;
        end;

      //        Link2M, Make2M
      phProCompiling, phLink2M, phMake2M:
        if GetExitCodeProcess(PInfo.hProcess, i) then begin
          if i <> 0 then inc(ProErrCount);
          end
        else begin
          inc(ProErrCount);
          WriteLog('   ');
          end;

      // ,       ,   NMake (Make) 
      phBuild: begin
        ClearProcessRunningMode;
        WriteLog('');
        if (not GetExitCodeProcess(PInfo.hProcess, i)) or (i <> 0) then
          WriteLog('     ')
        else
          WriteLog(' ,  ');
        end;

      //     O2M
      phVInfoO2M: begin
        ClearProcessRunningMode;
        CurrPhase := phVInfoLink2M;
        if not RunCreateProcess(Link2MPath + ' -v', false) then begin
          WriteLog(v_err + 'Link2M');
          goto skip_phase;
          end;
        end;

      //     Link2M
      phVInfoLink2M: begin
        ClearProcessRunningMode;
        CurrPhase := phVInfoMake2M;
        if not RunCreateProcess(Make2MPath + ' -v', false) then begin
          WriteLog(v_err + 'Make2M');
          goto skip_phase;
          end;
        end;

      //     Make2M
      phVInfoMake2M: begin
        ClearProcessRunningMode;
        WriteLog('');
        WriteLog(v_done);
        end;

      end;//case
    //     (  )
    exit;
    end;

  //  
  tmLogger.Enabled := true;
end;


//------------------------------------------------------------------------------
//  ,    
procedure TfrPro2M.tmShedullerTimer(Sender: TObject);
var st : string;
begin
  //  -
  if tmLogger.Enabled then exit;

  //  (    )
  tmSheduller.Enabled := false;

  //    (  )
  if phProCompiling = CurrPhase then
    //,        
    if CurrFileIndex >= CompFiles.Count then begin
      //  ,    ,    
      DeleteFile(tmp_pro_name);
      CurrPhase := phLink2M
      end
    else begin
      //    
      st := '"' + CompFiles[CurrFileIndex] + '"';
      WriteLog('');
      WriteLog(' ' + st + '...');
      if not RunCreateProcess('"' + O2MPath + '" ' + st + ' ' + tmp_pro_name + ' -a', false) then begin
        WriteLog('    ' + st);
        inc(ProErrCount);
        end;
      //    
      inc(CurrFileIndex);
      //       
      tmSheduller.Enabled := true;
      exit;
      end;

  //    (   Link2M)
  if phLink2M = CurrPhase then begin
    //  
    CurrPhase := phMake2M;
    //  Link2M
    WriteLog('');
    WriteLog(' Link2M...');
    if not RunCreateProcess('"' + Link2MPath + '" CPP/_O2M_make.2mk -a', false) then begin
      WriteLog('  Link2M');
      inc(ProErrCount);
      end;
    //       
    tmSheduller.Enabled := true;
    exit;
    end;

  //    (   Make2M)
  if phMake2M = CurrPhase then begin
    //  
    CurrPhase := phProComplete;
    //  Make2M
    WriteLog('');
    WriteLog(' Make2M...');
    case cbxTarget.ItemIndex of
      1: st := 'p 1';
      2: if WinToOEM then st := 'p 2 -c' else st := 'p 2';
      3: if WinToOEM then st := 'p 3 -c' else st := 'p 3';
    else
      st := 'p 0';
      end;
    if not RunCreateProcess('"' + Make2MPath + '" CPP/_O2M_make.2mk "CPP/' + Makefile + '" -a -' + st + ' -cp "' + CppPath + '"', false) then begin
      WriteLog('  Make2M');
      inc(ProErrCount);
      end;
    //       
    tmSheduller.Enabled := true;
    exit;
    end;

  //    
  if CurrPhase = phProComplete then begin
    WriteLog('');
    WriteLog('  , : ' + IntToStr(ProErrCount));
    //     
    ClearProcessRunningMode;
    end;

end;


//------------------------------------------------------------------------------
//    
procedure TfrPro2M.FormDestroy(Sender: TObject);
begin
  //  
  CompFiles.Free;
  //      
  bmMainFile.Free;
end;


//------------------------------------------------------------------------------
//  
procedure TfrPro2M.cbxTargetChange(Sender: TObject);
begin
  cbxTarget.Hint := cbxTarget.Text;
  //     
  set_chng;
end;


//------------------------------------------------------------------------------
// -   
procedure TfrPro2M.lbxFilesDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  st : string;  //    
begin
  with (Control as TListBox).Canvas do begin
    st := (Control as TListBox).Items[Index];
    // 
    FillRect(Rect);
    //,       
    if st = MainFile then
      BrushCopy(Bounds(Rect.Left, Rect.Top, bmMainFile.Width, bmMainFile.Height), bmMainFile, Bounds(0, 0, bmMainFile.Width, bmMainFile.Height), clBlue);
    // 
    TextOut(Rect.Left + bmMainFile.Width + 2, Rect.Top + 2, st);
    end;//with
end;


//------------------------------------------------------------------------------
//   
procedure TfrPro2M.miConfToolsClick(Sender: TObject);
begin
  frConfTools.ShowModal;
end;


//------------------------------------------------------------------------------
//  
procedure TfrPro2M.tbFileDownClick(Sender: TObject);
begin
  //   
  if lbxFiles.ItemIndex < 0 then begin
    MessageDlg('  ', mtWarning, [mbOK], 0);
    exit;
    end;//if
  //     
  if (lbxFiles.ItemIndex + 1) >= lbxFiles.Items.Count then exit;
  //   
  lbxFiles.Items.Exchange(lbxFiles.ItemIndex, lbxFiles.ItemIndex + 1);
  set_chng;
end;


//------------------------------------------------------------------------------
//  
procedure TfrPro2M.tbPathDownClick(Sender: TObject);
begin
  //   
  if lbxPaths.ItemIndex < 0 then begin
    MessageDlg('  ', mtWarning, [mbOK], 0);
    exit;
    end;//if
  //     
  if (lbxPaths.ItemIndex + 1) >= lbxPaths.Items.Count then exit;
  //   
  lbxPaths.Items.Exchange(lbxPaths.ItemIndex, lbxPaths.ItemIndex + 1);
end;


//------------------------------------------------------------------------------
//  
procedure TfrPro2M.miVersionInfoClick(Sender: TObject);
begin
  ClearLog;
  WriteLog('Pro2M ' + frAbout.lbVersion.Caption);
  WriteLog('');
  WriteLog('     ...');
  WriteLog('');
  //    O2M
  CurrPhase := phVInfoO2M;
  if not RunCreateProcess(O2MPath + ' -v', false) then begin
    WriteLog(v_err + 'O2M');
    //    Link2M
    CurrPhase := phVInfoLink2M;
    if not RunCreateProcess(Link2MPath + ' -v', false) then begin
      WriteLog(v_err + 'Link2M');
      //    Make2M
      CurrPhase := phVInfoMake2M;
      if not RunCreateProcess(Make2MPath + ' -v', false) then begin
        WriteLog(v_err + 'Make2M');
        WriteLog('');
        WriteLog(v_done);
        end;
      end;
    end;//if
end;


end.

