unit About;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls;

type
  TfrAbout = class(TForm)
    tmTimer: TTimer;
    pnOK: TPanel;
    sbOK: TSpeedButton;
    pnText: TPanel;
    pbText: TPaintBox;
    lbVersion: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure tmTimerTimer(Sender: TObject);
    procedure sbOKClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frAbout: TfrAbout;

implementation

{$R *.DFM}

//------------------------------------------------------------------------------
//    
var
  TextTop : integer;                  //  
  TextSpace : integer;                //   
  TextH : integer;                    //.   
  ArrHeight : integer;                //   
const
  TextCount = 9;                      //  

//  (    )
  TextArr : array [1..TextCount] of string =
    ('  ',
     '   ',
     '',
     ' ,  ',
     ':',
     '  ',
     ' :',
     '  ',
     ''
    );


//------------------------------------------------------------------------------
//     
procedure Show_flow_text;
var i : integer;                        //    
    x, y, tw : integer;
begin
with frAbout.pbText do begin
  //  
  for i := 1 to TextCount do begin
    tw := Canvas.TextWidth(TextArr[i]);
    x := (ClientWidth - tw) div 2;
    y := i * TextSpace + TextTop;
    Canvas.Rectangle(x, y, x + tw, y + TextH);
    end;
  //    . 
  if (- TextTop) > ArrHeight then  //   
    TextTop := ClientHeight        //   
  else
    dec(TextTop);                  //  1  
  //    
  Font.Color := clLime;
  for i := 1 to TextCount do
    Canvas.TextOut((ClientWidth - Canvas.TextWidth(TextArr[i])) div 2, i * TextSpace + TextTop, TextArr[i]);
  end;//with
end;


//------------------------------------------------------------------------------
//     
procedure Init_flow_text;
begin
with frAbout.pbText do begin
  //   
  TextH := Canvas.TextHeight('');   //   
  TextSpace := round(TextH * 1.5);
  ArrHeight := TextSpace * (TextCount + 1);
  //   
  TextTop := ClientHeight;
  end;//with
end;


//------------------------------------------------------------------------------
//    
procedure TfrAbout.FormShow(Sender: TObject);
begin
  //  ' ...'   
  Left := (Screen.Width - Width) div 2;
  Top := (Screen.Height - Height) div 2;
  //    
  Init_flow_text;
  //    
  tmTimer.Enabled := true;
end;


//------------------------------------------------------------------------------
//  ()
procedure TfrAbout.FormHide(Sender: TObject);
begin
  //    
  tmTimer.Enabled := false;
end;


//------------------------------------------------------------------------------
//    
procedure TfrAbout.tmTimerTimer(Sender: TObject);
begin
  Show_flow_text;
end;


//------------------------------------------------------------------------------
//   
procedure TfrAbout.sbOKClick(Sender: TObject);
begin
  Close;
end;


//------------------------------------------------------------------------------
//    
procedure TfrAbout.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key in [#27, #13] then begin
    Key := #0;
    Close;
    end;
end;


end.

